#pragma once

#include "stdafx.h"

#include <tchar.h>

#include <string>

#include <sstream>

#include <algorithm>

#include <windows.h>

#include <iostream>

#include <fstream>

#include <stdio.h>

#include <time.h>

#include <Strsafe.h>

using namespace std;

void wait ( int seconds )
{
  clock_t endwait;
  endwait = clock () + seconds * CLOCKS_PER_SEC ;
  while (clock() < endwait) {}
}

template <typename T>
std::string Int2Str(T arg)
{
    std::ostringstream buffer;
    buffer << arg; // send the type to the ostringstream
    return buffer.str(); // capture the string
}

template <typename T>
std::string IntToHex(T arg)
{
    std::ostringstream buffer;
    buffer << hex << arg; // send the type to the ostringstream
    return buffer.str(); // capture the string
}

template <typename T>
int HexToInt(T arg)
{
   int num;
   std::istringstream i(arg);
   i >> std::hex >> num;
   return num;
}

template <typename T>
unsigned int Str2Int(T arg)
{
   std::istringstream is(arg);
   unsigned int t;
   is >> t;
   return t;
}

template <typename T>
char Str2Char(T arg)
{
   std::istringstream is(arg);
   char t;
   is >> t;
   return t;
}

struct upper {
  int operator() ( int c )  
  {
      return toupper ( static_cast<unsigned char> ( c ) );
  }
  
};

struct lower {
  int operator() ( int c )  
  {
      return tolower ( static_cast<unsigned char> ( c ) );
  }
  
};

std::wstring StringToWString(const std::string& str)
{
   wstring temp_one;
   string temp(str.begin(), str.end());
   temp_one.assign(str.begin(), str.end());
   return temp_one; 
}

std::string WString2String(wstring str)
{
   string str1(str.begin(), str.end());
   str1.assign(str.begin(), str.end());
   return str1;
}

int Wstring2Int(wstring str)
{
   string str1 = WString2String(str);
   return Str2Int(str1);
}

char * Str2CharArray(string str)
{
   char CharArray[1000];
   char * Value;
   size_t l = 0;
   for (l = 0; l < str.length(); l++) {
      CharArray[l] = str.at(l);
   }
   for (size_t m = l; m < 1000; m++) {
      CharArray[m] = '\0';
   }
   Value = CharArray;
   return Value;
}

bool CI_Compare(string a,string b)
{
	std::transform(a.begin(),a.end(),a.begin(),upper());
	std::transform(b.begin(),b.end(),b.begin(),upper());
	size_t loc1 = a.find(b);
	if(loc1!=string::npos) {
		return true;
	}
	size_t loc2 = b.find(a);
	if(loc2!=string::npos) {
		return true;
	}
	return false;
}

string CopyStr(string str) 
{
  size_t length;
  char buffer[250];
  length=str.copy(buffer,str.length() + 1,0);
  buffer[length]='\0';
  return buffer;
}


string char2string(char * a)
{
   std::string d = "";
	d.append(a);
	return d;
}

char * CopyChar(char * arg )
{
   char * a = "";
   for(int i = 0; i<255;i++) {
      a[i] = arg[i];
   }

   return a;
}

string ExtractDirrectory(string InputFileName) {
	string slash = "\\";
	string str;
	slash.erase(1,1);
	slash=slash.c_str();
	size_t pos2 = InputFileName.find_last_of(slash);
	if(pos2!=string::npos) {
		str = InputFileName.erase(pos2 + 1);
	}
	return str;
}

string ExtractFileName(string InputFileName) {
	string slash = "\\";
	string str;
	slash.erase(1,1);
	size_t loc = InputFileName.find_last_of( slash );
	if (loc!=string::npos) {
	   InputFileName.erase(0,loc + 1);
   }
   return InputFileName;
}
























