// Moo2 Save Game Editor.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#include "Resource.h"

#include <tchar.h>

#include <string>

#include <sstream>

#include <algorithm>

#include <windows.h>

#include <iostream>

#include <fstream>

#include <stdio.h>

#include <time.h>

#include <WindowsX.h>

#include "Defines.h"

#include "BringUp.cpp"

#include "Scroll.cpp"

#include "BrowseForFile.cpp"

using namespace std;

INT_PTR CALLBACK ErrorDialog(HWND hError, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
   case WM_LBUTTONDOWN:  
      BringWindowToTop(hError);  
      break;

   HANDLE_MSG(hError, WM_INITDIALOG, SD_OnInitDialog);

   HANDLE_MSG(hError, WM_SIZE, SD_OnSize);

   HANDLE_MSG(hError, WM_HSCROLL, SD_OnHScroll);

   HANDLE_MSG(hError, WM_VSCROLL, SD_OnVScroll);

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
         ShowWindow(hError, SW_HIDE);
         SaveWindowRect("Error", hError);
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK FoodDescriptDialog(HWND hExplain, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
   case WM_LBUTTONDOWN:  
      BringWindowToTop(hExplain);  
      break;

   HANDLE_MSG(hExplain, WM_INITDIALOG, SD_OnInitDialog);

   HANDLE_MSG(hExplain, WM_SIZE, SD_OnSize);

   HANDLE_MSG(hExplain, WM_HSCROLL, SD_OnHScroll);

   HANDLE_MSG(hExplain, WM_VSCROLL, SD_OnVScroll);

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
         ShowWindow(hExplain, SW_HIDE);
         SaveWindowRect("Explain", hExplain);
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK AboutDialog(HWND hAbout, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
   case WM_LBUTTONDOWN:  
      BringWindowToTop(hAbout);  
      break;

   HANDLE_MSG(hAbout, WM_INITDIALOG, SD_OnInitDialog);

   HANDLE_MSG(hAbout, WM_SIZE, SD_OnSize);

   HANDLE_MSG(hAbout, WM_HSCROLL, SD_OnHScroll);

   HANDLE_MSG(hAbout, WM_VSCROLL, SD_OnVScroll);

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
         ShowWindow(hAbout, SW_HIDE);
         SaveWindowRect("About", hAbout);
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK SettingsDialog(HWND hSettings, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
   case WM_LBUTTONDOWN:  
      BringWindowToTop(hSettings);  
      break;

   HANDLE_MSG(hSettings, WM_INITDIALOG, SD_OnInitDialog);

   HANDLE_MSG(hSettings, WM_SIZE, SD_OnSize);

   HANDLE_MSG(hSettings, WM_HSCROLL, SD_OnHScroll);

   HANDLE_MSG(hSettings, WM_VSCROLL, SD_OnVScroll);

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
         ShowWindow(hSettings, SW_HIDE);
         SaveSettings(hSettings);
         SaveWindowRect("Settings", hSettings);
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDC_OPEN_SLOT)
		{
         SetDlgItemText(hSettings,IDC_LOAD_SLOT_NAME_BOX,BrowseForFile());
			return (INT_PTR)TRUE;
		}
      if (LOWORD(wParam) == IDC_SAVE_SLOT)
		{
         SetDlgItemText(hSettings,IDC_SAVE_SLOT_NAME_BOX,BrowseForFile());
			return (INT_PTR)TRUE;
		}
      if (LOWORD(wParam) == IDC_LOAD_SLOT_NAME)
		{
         if (Loaded == 0) {
            LoadSaveSlot();
         } else {
            MessageBox(NULL, "Dicarded Previous Changes.", "", MB_OK);
            LoadSaveSlot();
         }
			return (INT_PTR)TRUE;
		}
      if (LOWORD(wParam) == IDC_SAVE_SLOT_NAME)
		{
         if (Loaded == 1) {
            SaveSlot();
         } else {
            MessageBox(NULL, "You Have Not Loaded a Save Slot.", "", MB_OK);
         }
			return (INT_PTR)TRUE;
		}
      if (LOWORD(wParam) == IDC_SAVE_AND_QUIT)
		{
         if (Loaded == 1) {
            SaveSlot();
            ShowWindow(hSaveQuit, SW_SHOW);
            LoadWindowRect(0, "SaveQuit", hSaveQuit);
            SaveWindowRect("Settings", hSettings);
         } else {
            ShowWindow(hQuit, SW_SHOW);
            LoadWindowRect(0, "Quit", hQuit);
            SaveWindowRect("Settings", hSettings);
         }
			return (INT_PTR)TRUE;
		}
      if (LOWORD(wParam) == IDC_DELETE_REGISTRY)
		{
         ShowWindow(hRegistry, SW_SHOW);
         LoadWindowRect(0, "Registry", hRegistry);
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK GalaxyWideDialog(HWND hGalaxy, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
   case WM_LBUTTONDOWN:  
      BringWindowToTop(hGalaxy);  
      break;

   HANDLE_MSG(hGalaxy, WM_INITDIALOG, SD_OnInitDialog);

   HANDLE_MSG(hGalaxy, WM_SIZE, SD_OnSize);

   HANDLE_MSG(hGalaxy, WM_HSCROLL, SD_OnHScroll);

   HANDLE_MSG(hGalaxy, WM_VSCROLL, SD_OnVScroll);

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
         ShowWindow(hGalaxy, SW_HIDE);
         SaveWindowRect("Galaxy", hGalaxy);
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDC_FOOD_BASE_TAB)
		{
         ShowWindow(hFood, SW_SHOW);
         LoadWindowRect(0, "Food",hFood);
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDC_SAVE_FILE)
		{
         if (Loaded == 1) {
            AlterUnCreative();
            AlterGalaxy();
            SaveSettings(hSettings);
         } else {
            MessageBox(NULL, "You Have Not Loaded a Save Slot.", "", MB_OK);
         }
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK SaveQuitDialog(HWND hSaveQuit, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
   case WM_LBUTTONDOWN:  
      BringWindowToTop(hSaveQuit);  
      break;

   HANDLE_MSG(hSaveQuit, WM_INITDIALOG, SD_OnInitDialog);

   HANDLE_MSG(hSaveQuit, WM_SIZE, SD_OnSize);

   HANDLE_MSG(hSaveQuit, WM_HSCROLL, SD_OnHScroll);

   HANDLE_MSG(hSaveQuit, WM_VSCROLL, SD_OnVScroll);

	case WM_COMMAND:
		if (LOWORD(wParam) == IDC_QUIT)
		{
         DeleteFile(CopySaveSlot);
         SaveWindowRect("SaveQuit", hSaveQuit);
         PostQuitMessage(0);
         //exit(0);
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDC_SAVE)
		{
         SaveSlot();
         SaveWindowRect("SaveQuit", hSaveQuit);
         PostQuitMessage(0);
         //exit(0);
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDCANCEL)
		{
         SaveWindowRect("SaveQuit", hSaveQuit);
         ShowWindow(hSaveQuit, SW_HIDE);
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK FoodDialog(HWND hFood, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
   case WM_LBUTTONDOWN:  
      BringWindowToTop(hFood);  
      break;

   HANDLE_MSG(hFood, WM_INITDIALOG, SD_OnInitDialog);

   HANDLE_MSG(hFood, WM_SIZE, SD_OnSize);

   HANDLE_MSG(hFood, WM_HSCROLL, SD_OnHScroll);

   HANDLE_MSG(hFood, WM_VSCROLL, SD_OnVScroll);

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK)
		{
         ShowWindow(hFood, SW_HIDE);
         SaveWindowRect("Food", hFood);
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDC_EXPLAINATION)
		{
         ShowWindow(hExplain, SW_SHOW);
         LoadWindowRect(0, "Explain",hExplain);
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK QuitDialog(HWND hQuit, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
   case WM_LBUTTONDOWN:  
      BringWindowToTop(hQuit);  
      break;

   HANDLE_MSG(hQuit, WM_INITDIALOG, SD_OnInitDialog);

   HANDLE_MSG(hQuit, WM_SIZE, SD_OnSize);

   HANDLE_MSG(hQuit, WM_HSCROLL, SD_OnHScroll);

   HANDLE_MSG(hQuit, WM_VSCROLL, SD_OnVScroll);

	case WM_COMMAND:
		if (LOWORD(wParam) == IDC_QUIT_ANYWAY)
		{
         DeleteFile(CopySaveSlot);
         SaveWindowRect("Quit", hQuit);
         PostQuitMessage(0);
         //exit(0);
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDCANCEL)
		{
         SaveWindowRect("Quit", hQuit);
         ShowWindow(hQuit,SW_HIDE);
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK RegistryDialog(HWND hRegistry, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
   case WM_LBUTTONDOWN:
      BringWindowToTop(hRegistry);  
      break;

   HANDLE_MSG(hRegistry, WM_INITDIALOG, SD_OnInitDialog);

   HANDLE_MSG(hRegistry, WM_SIZE, SD_OnSize);

   HANDLE_MSG(hRegistry, WM_HSCROLL, SD_OnHScroll);

   HANDLE_MSG(hRegistry, WM_VSCROLL, SD_OnVScroll);

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
         ShowWindow(hRegistry, SW_HIDE);
         SaveWindowRect("Registry", hRegistry);
			return (INT_PTR)TRUE;
		}
		if (LOWORD(wParam) == IDC_YES_DELETE)
		{
         string OCL_Registry_Key = "Moo2 Save Editor By Nirran\\";

         HKEY hk;

         int check = RegOpenKeyEx(HKEY_CURRENT_USER, OCL_Registry_Key.c_str(), 0, KEY_SET_VALUE, &hk);

         if (check == 0) {
            RegDeleteTree(hk, NULL);
         }

         RegCloseKey(hk);

         ShowWindow(hRegistry, SW_HIDE);
         SaveWindowRect("Registry", hRegistry);
			return (INT_PTR)TRUE;
		}
		break;
   }
	return (INT_PTR)FALSE;
}


